; RUN: llc -filetype=obj -mtriple=avr -mattr=jmpcall < %s | llvm-objdump -dr --mattr=jmpcall - | FileCheck %s

; Test the fix in https://reviews.llvm.org/D78459.
; Long branches (that use jmp instead of rjmp) were broken: the jump was to a
; location 0x20000 away from where it should be. This test is a regression test
; to make sure long branches are correct.

declare void @bar() addrspace(1)

define void @foo() addrspace(1) {
  br label %1

1:                                                ; preds = %0, %1
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  tail call addrspace(0) void asm sideeffect "nop", ""()
  ; CHECK: call 0
  ; CHECK:      R_AVR_CALL bar
  ; CHECK: jmp  0
  ; CHECK:      R_AVR_CALL .text
  tail call addrspace(1) void @bar()
  br label %1
}
