// RUN: not llvm-mc -triple=amdgcn -mcpu=gfx1100 -mattr=+wavefrontsize32 -show-encoding %s | FileCheck --check-prefixes=GFX11,W32 %s
// RUN: not llvm-mc -triple=amdgcn -mcpu=gfx1100 -mattr=+wavefrontsize64 -show-encoding %s | FileCheck --check-prefixes=GFX11,W64 %s
// RUN: not llvm-mc -triple=amdgcn -mcpu=gfx1100 -mattr=+wavefrontsize32 %s 2>&1 | FileCheck --check-prefix=W32-ERR --implicit-check-not=error: %s
// RUN: not llvm-mc -triple=amdgcn -mcpu=gfx1100 -mattr=+wavefrontsize64 %s 2>&1 | FileCheck --check-prefix=W64-ERR --implicit-check-not=error: %s

v_add_co_ci_u32_dpp v5, vcc_lo, v1, v2, vcc_lo quad_perm:[3,2,1,0]
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x1b,0x00,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo quad_perm:[0,1,2,3]
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0xe4,0x00,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_mirror
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x40,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_half_mirror
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x41,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_shl:1
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x01,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_shl:15
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x0f,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_shr:1
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x11,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_shr:15
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x1f,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_ror:1
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x21,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_ror:15
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x2f,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_share:0 row_mask:0xf bank_mask:0xf
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x50,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_share:15 row_mask:0x0 bank_mask:0x1
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x5f,0x01,0x01]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// W32: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x60,0x09,0x13]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v255, vcc_lo, v255, v255, vcc_lo row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// W32: encoding: [0xfa,0xfe,0xff,0x41,0xff,0x6f,0x05,0x30]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc quad_perm:[3,2,1,0]
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x1b,0x00,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc quad_perm:[0,1,2,3]
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0xe4,0x00,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc row_mirror
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x40,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc row_half_mirror
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x41,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc row_shl:1
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x01,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc row_shl:15
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x0f,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc row_shr:1
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x11,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc row_shr:15
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x1f,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc row_ror:1
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x21,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc row_ror:15
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x2f,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc row_share:0 row_mask:0xf bank_mask:0xf
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x50,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc row_share:15 row_mask:0x0 bank_mask:0x1
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x5f,0x01,0x01]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v5, vcc, v1, v2, vcc row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// W64: encoding: [0xfa,0x04,0x0a,0x40,0x01,0x60,0x09,0x13]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_co_ci_u32 v255, vcc, v255, v255, vcc row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// W64: encoding: [0xfa,0xfe,0xff,0x41,0xff,0x6f,0x05,0x30]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_add_f16 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0x1b,0x00,0xff]

v_add_f16 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0xe4,0x00,0xff]

v_add_f16 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0x40,0x01,0xff]

v_add_f16 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0x41,0x01,0xff]

v_add_f16 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0x01,0x01,0xff]

v_add_f16 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0x0f,0x01,0xff]

v_add_f16 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0x11,0x01,0xff]

v_add_f16 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0x1f,0x01,0xff]

v_add_f16 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0x21,0x01,0xff]

v_add_f16 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0x2f,0x01,0xff]

v_add_f16 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0x50,0x01,0xff]

v_add_f16 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0x5f,0x01,0x01]

v_add_f16 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x64,0x01,0x60,0x09,0x13]

v_add_f16 v127, -|v127|, -|v127| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xfe,0x64,0x7f,0x6f,0xf5,0x30]

v_add_f32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0x1b,0x00,0xff]

v_add_f32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0xe4,0x00,0xff]

v_add_f32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0x40,0x01,0xff]

v_add_f32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0x41,0x01,0xff]

v_add_f32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0x01,0x01,0xff]

v_add_f32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0x0f,0x01,0xff]

v_add_f32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0x11,0x01,0xff]

v_add_f32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0x1f,0x01,0xff]

v_add_f32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0x21,0x01,0xff]

v_add_f32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0x2f,0x01,0xff]

v_add_f32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0x50,0x01,0xff]

v_add_f32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0x5f,0x01,0x01]

v_add_f32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x06,0x01,0x60,0x09,0x13]

v_add_f32 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x07,0xff,0x6f,0xf5,0x30]

v_add_nc_u32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0x1b,0x00,0xff]

v_add_nc_u32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0xe4,0x00,0xff]

v_add_nc_u32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0x40,0x01,0xff]

v_add_nc_u32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0x41,0x01,0xff]

v_add_nc_u32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0x01,0x01,0xff]

v_add_nc_u32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0x0f,0x01,0xff]

v_add_nc_u32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0x11,0x01,0xff]

v_add_nc_u32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0x1f,0x01,0xff]

v_add_nc_u32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0x21,0x01,0xff]

v_add_nc_u32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0x2f,0x01,0xff]

v_add_nc_u32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0x50,0x01,0xff]

v_add_nc_u32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0x5f,0x01,0x01]

v_add_nc_u32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x4a,0x01,0x60,0x09,0x13]

v_add_nc_u32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x4b,0xff,0x6f,0x05,0x30]

v_and_b32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0x1b,0x00,0xff]

v_and_b32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0xe4,0x00,0xff]

v_and_b32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0x40,0x01,0xff]

v_and_b32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0x41,0x01,0xff]

v_and_b32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0x01,0x01,0xff]

v_and_b32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0x0f,0x01,0xff]

v_and_b32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0x11,0x01,0xff]

v_and_b32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0x1f,0x01,0xff]

v_and_b32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0x21,0x01,0xff]

v_and_b32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0x2f,0x01,0xff]

v_and_b32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0x50,0x01,0xff]

v_and_b32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0x5f,0x01,0x01]

v_and_b32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x36,0x01,0x60,0x09,0x13]

v_and_b32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x37,0xff,0x6f,0x05,0x30]

v_ashrrev_i32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0x1b,0x00,0xff]

v_ashrrev_i32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0xe4,0x00,0xff]

v_ashrrev_i32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0x40,0x01,0xff]

v_ashrrev_i32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0x41,0x01,0xff]

v_ashrrev_i32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0x01,0x01,0xff]

v_ashrrev_i32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0x0f,0x01,0xff]

v_ashrrev_i32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0x11,0x01,0xff]

v_ashrrev_i32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0x1f,0x01,0xff]

v_ashrrev_i32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0x21,0x01,0xff]

v_ashrrev_i32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0x2f,0x01,0xff]

v_ashrrev_i32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0x50,0x01,0xff]

v_ashrrev_i32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0x5f,0x01,0x01]

v_ashrrev_i32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x34,0x01,0x60,0x09,0x13]

v_ashrrev_i32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x35,0xff,0x6f,0x05,0x30]

v_cndmask_b32 v5, v1, v2, vcc_lo quad_perm:[3,2,1,0]
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x1b,0x00,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc_lo quad_perm:[0,1,2,3]
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0xe4,0x00,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc_lo row_mirror
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x40,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc_lo row_half_mirror
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x41,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc_lo row_shl:1
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x01,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc_lo row_shl:15
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x0f,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc_lo row_shr:1
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x11,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc_lo row_shr:15
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x1f,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc_lo row_ror:1
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x21,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc_lo row_ror:15
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x2f,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc_lo row_share:0 row_mask:0xf bank_mask:0xf
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x50,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc_lo row_share:15 row_mask:0x0 bank_mask:0x1
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x5f,0x01,0x01]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc_lo row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x60,0x09,0x13]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, -v1, |v2|, vcc_lo quad_perm:[0,1,2,3] row_mask:0x0 bank_mask:0x0 bound_ctrl:0
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0xe4,0x90,0x00]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, |v1|, -v2, vcc_lo quad_perm:[0,1,2,3] row_mask:0x0 bank_mask:0x0 bound_ctrl:0
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0xe4,0x60,0x00]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, -|v1|, -|v2|, vcc_lo quad_perm:[0,1,2,3] row_mask:0x0 bank_mask:0x0 bound_ctrl:0
// W32: encoding: [0xfa,0x04,0x0a,0x02,0x01,0xe4,0xf0,0x00]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v255, v255, v255, vcc_lo row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// W32: encoding: [0xfa,0xfe,0xff,0x03,0xff,0x6f,0x05,0x30]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc quad_perm:[3,2,1,0]
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x1b,0x00,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc quad_perm:[0,1,2,3]
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0xe4,0x00,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc row_mirror
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x40,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc row_half_mirror
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x41,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc row_shl:1
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x01,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc row_shl:15
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x0f,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc row_shr:1
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x11,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc row_shr:15
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x1f,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc row_ror:1
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x21,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc row_ror:15
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x2f,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc row_share:0 row_mask:0xf bank_mask:0xf
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x50,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc row_share:15 row_mask:0x0 bank_mask:0x1
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x5f,0x01,0x01]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v5, v1, v2, vcc row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0x60,0x09,0x13]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32 v255, v255, v255, vcc row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// W64: encoding: [0xfa,0xfe,0xff,0x03,0xff,0x6f,0x05,0x30]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32_dpp v5, -v1, |v2|, vcc quad_perm:[0,1,2,3] row_mask:0x0 bank_mask:0x0 bound_ctrl:0
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0xe4,0x90,0x00]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32_dpp v5, |v1|, -v2, vcc quad_perm:[0,1,2,3] row_mask:0x0 bank_mask:0x0 bound_ctrl:0
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0xe4,0x60,0x00]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cndmask_b32_dpp v5, -|v1|, -|v2|, vcc quad_perm:[0,1,2,3] row_mask:0x0 bank_mask:0x0 bound_ctrl:0
// W64: encoding: [0xfa,0x04,0x0a,0x02,0x01,0xe4,0xf0,0x00]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_cvt_pk_rtz_f16_f32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x1b,0x00,0xff]

v_cvt_pk_rtz_f16_f32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0xe4,0x00,0xff]

v_cvt_pk_rtz_f16_f32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x40,0x01,0xff]

v_cvt_pk_rtz_f16_f32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x41,0x01,0xff]

v_cvt_pk_rtz_f16_f32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x01,0x01,0xff]

v_cvt_pk_rtz_f16_f32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x0f,0x01,0xff]

v_cvt_pk_rtz_f16_f32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x11,0x01,0xff]

v_cvt_pk_rtz_f16_f32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x1f,0x01,0xff]

v_cvt_pk_rtz_f16_f32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x21,0x01,0xff]

v_cvt_pk_rtz_f16_f32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x2f,0x01,0xff]

v_cvt_pk_rtz_f16_f32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x50,0x01,0xff]

v_cvt_pk_rtz_f16_f32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x5f,0x01,0x01]

v_cvt_pk_rtz_f16_f32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x60,0x09,0x13]

v_cvt_pk_rtz_f16_f32 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x5f,0xff,0x6f,0xf5,0x30]

v_cvt_pkrtz_f16_f32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x1b,0x00,0xff]

v_cvt_pkrtz_f16_f32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0xe4,0x00,0xff]

v_cvt_pkrtz_f16_f32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x40,0x01,0xff]

v_cvt_pkrtz_f16_f32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x41,0x01,0xff]

v_cvt_pkrtz_f16_f32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x01,0x01,0xff]

v_cvt_pkrtz_f16_f32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x0f,0x01,0xff]

v_cvt_pkrtz_f16_f32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x11,0x01,0xff]

v_cvt_pkrtz_f16_f32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x1f,0x01,0xff]

v_cvt_pkrtz_f16_f32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x21,0x01,0xff]

v_cvt_pkrtz_f16_f32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x2f,0x01,0xff]

v_cvt_pkrtz_f16_f32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x50,0x01,0xff]

v_cvt_pkrtz_f16_f32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x5f,0x01,0x01]

v_cvt_pkrtz_f16_f32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x5e,0x01,0x60,0x09,0x13]

v_cvt_pkrtz_f16_f32 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x5f,0xff,0x6f,0xf5,0x30]

v_dot2acc_f32_f16 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x1b,0x00,0xff]

v_dot2acc_f32_f16 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0xe4,0x00,0xff]

v_dot2acc_f32_f16 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x40,0x01,0xff]

v_dot2acc_f32_f16 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x41,0x01,0xff]

v_dot2acc_f32_f16 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x01,0x01,0xff]

v_dot2acc_f32_f16 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x0f,0x01,0xff]

v_dot2acc_f32_f16 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x11,0x01,0xff]

v_dot2acc_f32_f16 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x1f,0x01,0xff]

v_dot2acc_f32_f16 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x21,0x01,0xff]

v_dot2acc_f32_f16 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x2f,0x01,0xff]

v_dot2acc_f32_f16 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x50,0x01,0xff]

v_dot2acc_f32_f16 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x5f,0x01,0x01]

v_dot2acc_f32_f16 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x60,0x09,0x13]

v_dot2acc_f32_f16 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x05,0xff,0x6f,0xf5,0x30]

v_dot2c_f32_f16 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x1b,0x00,0xff]

v_dot2c_f32_f16 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0xe4,0x00,0xff]

v_dot2c_f32_f16 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x40,0x01,0xff]

v_dot2c_f32_f16 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x41,0x01,0xff]

v_dot2c_f32_f16 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x01,0x01,0xff]

v_dot2c_f32_f16 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x0f,0x01,0xff]

v_dot2c_f32_f16 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x11,0x01,0xff]

v_dot2c_f32_f16 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x1f,0x01,0xff]

v_dot2c_f32_f16 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x21,0x01,0xff]

v_dot2c_f32_f16 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x2f,0x01,0xff]

v_dot2c_f32_f16 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x50,0x01,0xff]

v_dot2c_f32_f16 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x5f,0x01,0x01]

v_dot2c_f32_f16 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x04,0x01,0x60,0x09,0x13]

v_dot2c_f32_f16 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x05,0xff,0x6f,0xf5,0x30]

v_fmac_f16 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0x1b,0x00,0xff]

v_fmac_f16 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0xe4,0x00,0xff]

v_fmac_f16 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0x40,0x01,0xff]

v_fmac_f16 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0x41,0x01,0xff]

v_fmac_f16 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0x01,0x01,0xff]

v_fmac_f16 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0x0f,0x01,0xff]

v_fmac_f16 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0x11,0x01,0xff]

v_fmac_f16 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0x1f,0x01,0xff]

v_fmac_f16 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0x21,0x01,0xff]

v_fmac_f16 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0x2f,0x01,0xff]

v_fmac_f16 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0x50,0x01,0xff]

v_fmac_f16 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0x5f,0x01,0x01]

v_fmac_f16 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x6c,0x01,0x60,0x09,0x13]

v_fmac_f16 v127, -|v127|, -|v127| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xfe,0x6c,0x7f,0x6f,0xf5,0x30]

v_fmac_f32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0x1b,0x00,0xff]

v_fmac_f32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0xe4,0x00,0xff]

v_fmac_f32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0x40,0x01,0xff]

v_fmac_f32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0x41,0x01,0xff]

v_fmac_f32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0x01,0x01,0xff]

v_fmac_f32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0x0f,0x01,0xff]

v_fmac_f32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0x11,0x01,0xff]

v_fmac_f32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0x1f,0x01,0xff]

v_fmac_f32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0x21,0x01,0xff]

v_fmac_f32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0x2f,0x01,0xff]

v_fmac_f32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0x50,0x01,0xff]

v_fmac_f32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0x5f,0x01,0x01]

v_fmac_f32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x56,0x01,0x60,0x09,0x13]

v_fmac_f32 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x57,0xff,0x6f,0xf5,0x30]

v_ldexp_f16 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0x1b,0x00,0xff]

v_ldexp_f16 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0xe4,0x00,0xff]

v_ldexp_f16 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0x40,0x01,0xff]

v_ldexp_f16 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0x41,0x01,0xff]

v_ldexp_f16 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0x01,0x01,0xff]

v_ldexp_f16 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0x0f,0x01,0xff]

v_ldexp_f16 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0x11,0x01,0xff]

v_ldexp_f16 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0x1f,0x01,0xff]

v_ldexp_f16 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0x21,0x01,0xff]

v_ldexp_f16 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0x2f,0x01,0xff]

v_ldexp_f16 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0x50,0x01,0xff]

v_ldexp_f16 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0x5f,0x01,0x01]

v_ldexp_f16 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x76,0x01,0x60,0x09,0x13]

v_ldexp_f16 v127, -|v127|, v127 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xfe,0x76,0x7f,0x6f,0x35,0x30]

v_lshlrev_b32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0x1b,0x00,0xff]

v_lshlrev_b32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0xe4,0x00,0xff]

v_lshlrev_b32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0x40,0x01,0xff]

v_lshlrev_b32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0x41,0x01,0xff]

v_lshlrev_b32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0x01,0x01,0xff]

v_lshlrev_b32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0x0f,0x01,0xff]

v_lshlrev_b32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0x11,0x01,0xff]

v_lshlrev_b32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0x1f,0x01,0xff]

v_lshlrev_b32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0x21,0x01,0xff]

v_lshlrev_b32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0x2f,0x01,0xff]

v_lshlrev_b32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0x50,0x01,0xff]

v_lshlrev_b32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0x5f,0x01,0x01]

v_lshlrev_b32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x30,0x01,0x60,0x09,0x13]

v_lshlrev_b32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x31,0xff,0x6f,0x05,0x30]

v_lshrrev_b32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0x1b,0x00,0xff]

v_lshrrev_b32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0xe4,0x00,0xff]

v_lshrrev_b32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0x40,0x01,0xff]

v_lshrrev_b32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0x41,0x01,0xff]

v_lshrrev_b32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0x01,0x01,0xff]

v_lshrrev_b32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0x0f,0x01,0xff]

v_lshrrev_b32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0x11,0x01,0xff]

v_lshrrev_b32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0x1f,0x01,0xff]

v_lshrrev_b32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0x21,0x01,0xff]

v_lshrrev_b32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0x2f,0x01,0xff]

v_lshrrev_b32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0x50,0x01,0xff]

v_lshrrev_b32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0x5f,0x01,0x01]

v_lshrrev_b32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x32,0x01,0x60,0x09,0x13]

v_lshrrev_b32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x33,0xff,0x6f,0x05,0x30]

v_max_f16 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0x1b,0x00,0xff]

v_max_f16 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0xe4,0x00,0xff]

v_max_f16 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0x40,0x01,0xff]

v_max_f16 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0x41,0x01,0xff]

v_max_f16 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0x01,0x01,0xff]

v_max_f16 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0x0f,0x01,0xff]

v_max_f16 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0x11,0x01,0xff]

v_max_f16 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0x1f,0x01,0xff]

v_max_f16 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0x21,0x01,0xff]

v_max_f16 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0x2f,0x01,0xff]

v_max_f16 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0x50,0x01,0xff]

v_max_f16 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0x5f,0x01,0x01]

v_max_f16 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x72,0x01,0x60,0x09,0x13]

v_max_f16 v127, -|v127|, -|v127| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xfe,0x72,0x7f,0x6f,0xf5,0x30]

v_max_f32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0x1b,0x00,0xff]

v_max_f32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0xe4,0x00,0xff]

v_max_f32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0x40,0x01,0xff]

v_max_f32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0x41,0x01,0xff]

v_max_f32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0x01,0x01,0xff]

v_max_f32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0x0f,0x01,0xff]

v_max_f32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0x11,0x01,0xff]

v_max_f32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0x1f,0x01,0xff]

v_max_f32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0x21,0x01,0xff]

v_max_f32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0x2f,0x01,0xff]

v_max_f32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0x50,0x01,0xff]

v_max_f32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0x5f,0x01,0x01]

v_max_f32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x20,0x01,0x60,0x09,0x13]

v_max_f32 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x21,0xff,0x6f,0xf5,0x30]

v_max_i32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0x1b,0x00,0xff]

v_max_i32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0xe4,0x00,0xff]

v_max_i32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0x40,0x01,0xff]

v_max_i32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0x41,0x01,0xff]

v_max_i32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0x01,0x01,0xff]

v_max_i32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0x0f,0x01,0xff]

v_max_i32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0x11,0x01,0xff]

v_max_i32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0x1f,0x01,0xff]

v_max_i32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0x21,0x01,0xff]

v_max_i32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0x2f,0x01,0xff]

v_max_i32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0x50,0x01,0xff]

v_max_i32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0x5f,0x01,0x01]

v_max_i32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x24,0x01,0x60,0x09,0x13]

v_max_i32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x25,0xff,0x6f,0x05,0x30]

v_max_u32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0x1b,0x00,0xff]

v_max_u32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0xe4,0x00,0xff]

v_max_u32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0x40,0x01,0xff]

v_max_u32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0x41,0x01,0xff]

v_max_u32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0x01,0x01,0xff]

v_max_u32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0x0f,0x01,0xff]

v_max_u32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0x11,0x01,0xff]

v_max_u32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0x1f,0x01,0xff]

v_max_u32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0x21,0x01,0xff]

v_max_u32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0x2f,0x01,0xff]

v_max_u32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0x50,0x01,0xff]

v_max_u32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0x5f,0x01,0x01]

v_max_u32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x28,0x01,0x60,0x09,0x13]

v_max_u32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x29,0xff,0x6f,0x05,0x30]

v_min_f16 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0x1b,0x00,0xff]

v_min_f16 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0xe4,0x00,0xff]

v_min_f16 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0x40,0x01,0xff]

v_min_f16 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0x41,0x01,0xff]

v_min_f16 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0x01,0x01,0xff]

v_min_f16 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0x0f,0x01,0xff]

v_min_f16 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0x11,0x01,0xff]

v_min_f16 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0x1f,0x01,0xff]

v_min_f16 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0x21,0x01,0xff]

v_min_f16 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0x2f,0x01,0xff]

v_min_f16 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0x50,0x01,0xff]

v_min_f16 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0x5f,0x01,0x01]

v_min_f16 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x74,0x01,0x60,0x09,0x13]

v_min_f16 v127, -|v127|, -|v127| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xfe,0x74,0x7f,0x6f,0xf5,0x30]

v_min_f32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0x1b,0x00,0xff]

v_min_f32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0xe4,0x00,0xff]

v_min_f32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0x40,0x01,0xff]

v_min_f32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0x41,0x01,0xff]

v_min_f32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0x01,0x01,0xff]

v_min_f32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0x0f,0x01,0xff]

v_min_f32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0x11,0x01,0xff]

v_min_f32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0x1f,0x01,0xff]

v_min_f32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0x21,0x01,0xff]

v_min_f32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0x2f,0x01,0xff]

v_min_f32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0x50,0x01,0xff]

v_min_f32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0x5f,0x01,0x01]

v_min_f32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x1e,0x01,0x60,0x09,0x13]

v_min_f32 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x1f,0xff,0x6f,0xf5,0x30]

v_min_i32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0x1b,0x00,0xff]

v_min_i32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0xe4,0x00,0xff]

v_min_i32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0x40,0x01,0xff]

v_min_i32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0x41,0x01,0xff]

v_min_i32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0x01,0x01,0xff]

v_min_i32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0x0f,0x01,0xff]

v_min_i32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0x11,0x01,0xff]

v_min_i32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0x1f,0x01,0xff]

v_min_i32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0x21,0x01,0xff]

v_min_i32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0x2f,0x01,0xff]

v_min_i32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0x50,0x01,0xff]

v_min_i32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0x5f,0x01,0x01]

v_min_i32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x22,0x01,0x60,0x09,0x13]

v_min_i32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x23,0xff,0x6f,0x05,0x30]

v_min_u32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0x1b,0x00,0xff]

v_min_u32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0xe4,0x00,0xff]

v_min_u32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0x40,0x01,0xff]

v_min_u32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0x41,0x01,0xff]

v_min_u32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0x01,0x01,0xff]

v_min_u32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0x0f,0x01,0xff]

v_min_u32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0x11,0x01,0xff]

v_min_u32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0x1f,0x01,0xff]

v_min_u32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0x21,0x01,0xff]

v_min_u32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0x2f,0x01,0xff]

v_min_u32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0x50,0x01,0xff]

v_min_u32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0x5f,0x01,0x01]

v_min_u32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x26,0x01,0x60,0x09,0x13]

v_min_u32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x27,0xff,0x6f,0x05,0x30]

v_mul_dx9_zero_f32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x1b,0x00,0xff]

v_mul_dx9_zero_f32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0xe4,0x00,0xff]

v_mul_dx9_zero_f32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x40,0x01,0xff]

v_mul_dx9_zero_f32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x41,0x01,0xff]

v_mul_dx9_zero_f32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x01,0x01,0xff]

v_mul_dx9_zero_f32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x0f,0x01,0xff]

v_mul_dx9_zero_f32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x11,0x01,0xff]

v_mul_dx9_zero_f32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x1f,0x01,0xff]

v_mul_dx9_zero_f32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x21,0x01,0xff]

v_mul_dx9_zero_f32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x2f,0x01,0xff]

v_mul_dx9_zero_f32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x50,0x01,0xff]

v_mul_dx9_zero_f32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x5f,0x01,0x01]

v_mul_dx9_zero_f32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x60,0x09,0x13]

v_mul_dx9_zero_f32 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x0f,0xff,0x6f,0xf5,0x30]

v_mul_f16 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0x1b,0x00,0xff]

v_mul_f16 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0xe4,0x00,0xff]

v_mul_f16 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0x40,0x01,0xff]

v_mul_f16 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0x41,0x01,0xff]

v_mul_f16 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0x01,0x01,0xff]

v_mul_f16 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0x0f,0x01,0xff]

v_mul_f16 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0x11,0x01,0xff]

v_mul_f16 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0x1f,0x01,0xff]

v_mul_f16 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0x21,0x01,0xff]

v_mul_f16 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0x2f,0x01,0xff]

v_mul_f16 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0x50,0x01,0xff]

v_mul_f16 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0x5f,0x01,0x01]

v_mul_f16 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x6a,0x01,0x60,0x09,0x13]

v_mul_f16 v127, -|v127|, -|v127| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xfe,0x6a,0x7f,0x6f,0xf5,0x30]

v_mul_f32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0x1b,0x00,0xff]

v_mul_f32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0xe4,0x00,0xff]

v_mul_f32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0x40,0x01,0xff]

v_mul_f32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0x41,0x01,0xff]

v_mul_f32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0x01,0x01,0xff]

v_mul_f32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0x0f,0x01,0xff]

v_mul_f32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0x11,0x01,0xff]

v_mul_f32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0x1f,0x01,0xff]

v_mul_f32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0x21,0x01,0xff]

v_mul_f32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0x2f,0x01,0xff]

v_mul_f32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0x50,0x01,0xff]

v_mul_f32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0x5f,0x01,0x01]

v_mul_f32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x10,0x01,0x60,0x09,0x13]

v_mul_f32 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x11,0xff,0x6f,0xf5,0x30]

v_mul_hi_i32_i24 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0x1b,0x00,0xff]

v_mul_hi_i32_i24 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0xe4,0x00,0xff]

v_mul_hi_i32_i24 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0x40,0x01,0xff]

v_mul_hi_i32_i24 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0x41,0x01,0xff]

v_mul_hi_i32_i24 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0x01,0x01,0xff]

v_mul_hi_i32_i24 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0x0f,0x01,0xff]

v_mul_hi_i32_i24 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0x11,0x01,0xff]

v_mul_hi_i32_i24 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0x1f,0x01,0xff]

v_mul_hi_i32_i24 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0x21,0x01,0xff]

v_mul_hi_i32_i24 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0x2f,0x01,0xff]

v_mul_hi_i32_i24 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0x50,0x01,0xff]

v_mul_hi_i32_i24 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0x5f,0x01,0x01]

v_mul_hi_i32_i24 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x14,0x01,0x60,0x09,0x13]

v_mul_hi_i32_i24 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x15,0xff,0x6f,0x05,0x30]

v_mul_hi_u32_u24 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0x1b,0x00,0xff]

v_mul_hi_u32_u24 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0xe4,0x00,0xff]

v_mul_hi_u32_u24 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0x40,0x01,0xff]

v_mul_hi_u32_u24 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0x41,0x01,0xff]

v_mul_hi_u32_u24 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0x01,0x01,0xff]

v_mul_hi_u32_u24 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0x0f,0x01,0xff]

v_mul_hi_u32_u24 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0x11,0x01,0xff]

v_mul_hi_u32_u24 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0x1f,0x01,0xff]

v_mul_hi_u32_u24 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0x21,0x01,0xff]

v_mul_hi_u32_u24 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0x2f,0x01,0xff]

v_mul_hi_u32_u24 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0x50,0x01,0xff]

v_mul_hi_u32_u24 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0x5f,0x01,0x01]

v_mul_hi_u32_u24 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x18,0x01,0x60,0x09,0x13]

v_mul_hi_u32_u24 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x19,0xff,0x6f,0x05,0x30]

v_mul_i32_i24 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0x1b,0x00,0xff]

v_mul_i32_i24 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0xe4,0x00,0xff]

v_mul_i32_i24 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0x40,0x01,0xff]

v_mul_i32_i24 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0x41,0x01,0xff]

v_mul_i32_i24 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0x01,0x01,0xff]

v_mul_i32_i24 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0x0f,0x01,0xff]

v_mul_i32_i24 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0x11,0x01,0xff]

v_mul_i32_i24 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0x1f,0x01,0xff]

v_mul_i32_i24 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0x21,0x01,0xff]

v_mul_i32_i24 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0x2f,0x01,0xff]

v_mul_i32_i24 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0x50,0x01,0xff]

v_mul_i32_i24 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0x5f,0x01,0x01]

v_mul_i32_i24 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x12,0x01,0x60,0x09,0x13]

v_mul_i32_i24 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x13,0xff,0x6f,0x05,0x30]

v_mul_legacy_f32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x1b,0x00,0xff]

v_mul_legacy_f32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0xe4,0x00,0xff]

v_mul_legacy_f32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x40,0x01,0xff]

v_mul_legacy_f32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x41,0x01,0xff]

v_mul_legacy_f32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x01,0x01,0xff]

v_mul_legacy_f32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x0f,0x01,0xff]

v_mul_legacy_f32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x11,0x01,0xff]

v_mul_legacy_f32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x1f,0x01,0xff]

v_mul_legacy_f32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x21,0x01,0xff]

v_mul_legacy_f32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x2f,0x01,0xff]

v_mul_legacy_f32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x50,0x01,0xff]

v_mul_legacy_f32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x5f,0x01,0x01]

v_mul_legacy_f32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x0e,0x01,0x60,0x09,0x13]

v_mul_legacy_f32 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x0f,0xff,0x6f,0xf5,0x30]

v_mul_u32_u24 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0x1b,0x00,0xff]

v_mul_u32_u24 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0xe4,0x00,0xff]

v_mul_u32_u24 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0x40,0x01,0xff]

v_mul_u32_u24 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0x41,0x01,0xff]

v_mul_u32_u24 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0x01,0x01,0xff]

v_mul_u32_u24 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0x0f,0x01,0xff]

v_mul_u32_u24 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0x11,0x01,0xff]

v_mul_u32_u24 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0x1f,0x01,0xff]

v_mul_u32_u24 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0x21,0x01,0xff]

v_mul_u32_u24 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0x2f,0x01,0xff]

v_mul_u32_u24 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0x50,0x01,0xff]

v_mul_u32_u24 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0x5f,0x01,0x01]

v_mul_u32_u24 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x16,0x01,0x60,0x09,0x13]

v_mul_u32_u24 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x17,0xff,0x6f,0x05,0x30]

v_or_b32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0x1b,0x00,0xff]

v_or_b32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0xe4,0x00,0xff]

v_or_b32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0x40,0x01,0xff]

v_or_b32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0x41,0x01,0xff]

v_or_b32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0x01,0x01,0xff]

v_or_b32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0x0f,0x01,0xff]

v_or_b32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0x11,0x01,0xff]

v_or_b32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0x1f,0x01,0xff]

v_or_b32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0x21,0x01,0xff]

v_or_b32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0x2f,0x01,0xff]

v_or_b32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0x50,0x01,0xff]

v_or_b32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0x5f,0x01,0x01]

v_or_b32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x38,0x01,0x60,0x09,0x13]

v_or_b32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x39,0xff,0x6f,0x05,0x30]

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo quad_perm:[3,2,1,0]
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x1b,0x00,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo quad_perm:[0,1,2,3]
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0xe4,0x00,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_mirror
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x40,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_half_mirror
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x41,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_shl:1
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x01,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_shl:15
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x0f,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_shr:1
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x11,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_shr:15
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x1f,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_ror:1
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x21,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_ror:15
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x2f,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_share:0 row_mask:0xf bank_mask:0xf
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x50,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_share:15 row_mask:0x0 bank_mask:0x1
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x5f,0x01,0x01]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// W32: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x60,0x09,0x13]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v255, vcc_lo, v255, v255, vcc_lo row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// W32: encoding: [0xfa,0xfe,0xff,0x43,0xff,0x6f,0x05,0x30]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc quad_perm:[3,2,1,0]
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x1b,0x00,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc quad_perm:[0,1,2,3]
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0xe4,0x00,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc row_mirror
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x40,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc row_half_mirror
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x41,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc row_shl:1
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x01,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc row_shl:15
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x0f,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc row_shr:1
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x11,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc row_shr:15
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x1f,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc row_ror:1
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x21,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc row_ror:15
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x2f,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc row_share:0 row_mask:0xf bank_mask:0xf
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x50,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc row_share:15 row_mask:0x0 bank_mask:0x1
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x5f,0x01,0x01]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v5, vcc, v1, v2, vcc row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// W64: encoding: [0xfa,0x04,0x0a,0x42,0x01,0x60,0x09,0x13]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_co_ci_u32 v255, vcc, v255, v255, vcc row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// W64: encoding: [0xfa,0xfe,0xff,0x43,0xff,0x6f,0x05,0x30]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_sub_f16 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0x1b,0x00,0xff]

v_sub_f16 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0xe4,0x00,0xff]

v_sub_f16 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0x40,0x01,0xff]

v_sub_f16 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0x41,0x01,0xff]

v_sub_f16 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0x01,0x01,0xff]

v_sub_f16 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0x0f,0x01,0xff]

v_sub_f16 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0x11,0x01,0xff]

v_sub_f16 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0x1f,0x01,0xff]

v_sub_f16 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0x21,0x01,0xff]

v_sub_f16 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0x2f,0x01,0xff]

v_sub_f16 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0x50,0x01,0xff]

v_sub_f16 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0x5f,0x01,0x01]

v_sub_f16 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x66,0x01,0x60,0x09,0x13]

v_sub_f16 v127, -|v127|, -|v127| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xfe,0x66,0x7f,0x6f,0xf5,0x30]

v_sub_f32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0x1b,0x00,0xff]

v_sub_f32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0xe4,0x00,0xff]

v_sub_f32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0x40,0x01,0xff]

v_sub_f32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0x41,0x01,0xff]

v_sub_f32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0x01,0x01,0xff]

v_sub_f32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0x0f,0x01,0xff]

v_sub_f32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0x11,0x01,0xff]

v_sub_f32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0x1f,0x01,0xff]

v_sub_f32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0x21,0x01,0xff]

v_sub_f32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0x2f,0x01,0xff]

v_sub_f32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0x50,0x01,0xff]

v_sub_f32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0x5f,0x01,0x01]

v_sub_f32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x08,0x01,0x60,0x09,0x13]

v_sub_f32 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x09,0xff,0x6f,0xf5,0x30]

v_sub_nc_u32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0x1b,0x00,0xff]

v_sub_nc_u32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0xe4,0x00,0xff]

v_sub_nc_u32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0x40,0x01,0xff]

v_sub_nc_u32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0x41,0x01,0xff]

v_sub_nc_u32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0x01,0x01,0xff]

v_sub_nc_u32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0x0f,0x01,0xff]

v_sub_nc_u32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0x11,0x01,0xff]

v_sub_nc_u32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0x1f,0x01,0xff]

v_sub_nc_u32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0x21,0x01,0xff]

v_sub_nc_u32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0x2f,0x01,0xff]

v_sub_nc_u32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0x50,0x01,0xff]

v_sub_nc_u32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0x5f,0x01,0x01]

v_sub_nc_u32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x4c,0x01,0x60,0x09,0x13]

v_sub_nc_u32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x4d,0xff,0x6f,0x05,0x30]

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo quad_perm:[3,2,1,0]
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x1b,0x00,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo quad_perm:[0,1,2,3]
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0xe4,0x00,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_mirror
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x40,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_half_mirror
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x41,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_shl:1
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x01,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_shl:15
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x0f,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_shr:1
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x11,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_shr:15
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x1f,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_ror:1
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x21,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_ror:15
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x2f,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_share:0 row_mask:0xf bank_mask:0xf
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x50,0x01,0xff]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_share:15 row_mask:0x0 bank_mask:0x1
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x5f,0x01,0x01]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc_lo, v1, v2, vcc_lo row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// W32: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x60,0x09,0x13]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v255, vcc_lo, v255, v255, vcc_lo row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// W32: encoding: [0xfa,0xfe,0xff,0x45,0xff,0x6f,0x05,0x30]
// W64-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc quad_perm:[3,2,1,0]
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x1b,0x00,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc quad_perm:[0,1,2,3]
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0xe4,0x00,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc row_mirror
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x40,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc row_half_mirror
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x41,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc row_shl:1
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x01,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc row_shl:15
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x0f,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc row_shr:1
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x11,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc row_shr:15
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x1f,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc row_ror:1
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x21,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc row_ror:15
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x2f,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc row_share:0 row_mask:0xf bank_mask:0xf
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x50,0x01,0xff]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc row_share:15 row_mask:0x0 bank_mask:0x1
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x5f,0x01,0x01]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v5, vcc, v1, v2, vcc row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// W64: encoding: [0xfa,0x04,0x0a,0x44,0x01,0x60,0x09,0x13]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_co_ci_u32 v255, vcc, v255, v255, vcc row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// W64: encoding: [0xfa,0xfe,0xff,0x45,0xff,0x6f,0x05,0x30]
// W32-ERR: :[[@LINE-2]]:{{[0-9]+}}: error: operands are not valid for this GPU or mode

v_subrev_f16 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0x1b,0x00,0xff]

v_subrev_f16 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0xe4,0x00,0xff]

v_subrev_f16 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0x40,0x01,0xff]

v_subrev_f16 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0x41,0x01,0xff]

v_subrev_f16 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0x01,0x01,0xff]

v_subrev_f16 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0x0f,0x01,0xff]

v_subrev_f16 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0x11,0x01,0xff]

v_subrev_f16 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0x1f,0x01,0xff]

v_subrev_f16 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0x21,0x01,0xff]

v_subrev_f16 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0x2f,0x01,0xff]

v_subrev_f16 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0x50,0x01,0xff]

v_subrev_f16 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0x5f,0x01,0x01]

v_subrev_f16 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x68,0x01,0x60,0x09,0x13]

v_subrev_f16 v127, -|v127|, -|v127| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xfe,0x68,0x7f,0x6f,0xf5,0x30]

v_subrev_f32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0x1b,0x00,0xff]

v_subrev_f32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0xe4,0x00,0xff]

v_subrev_f32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0x40,0x01,0xff]

v_subrev_f32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0x41,0x01,0xff]

v_subrev_f32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0x01,0x01,0xff]

v_subrev_f32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0x0f,0x01,0xff]

v_subrev_f32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0x11,0x01,0xff]

v_subrev_f32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0x1f,0x01,0xff]

v_subrev_f32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0x21,0x01,0xff]

v_subrev_f32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0x2f,0x01,0xff]

v_subrev_f32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0x50,0x01,0xff]

v_subrev_f32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0x5f,0x01,0x01]

v_subrev_f32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x0a,0x01,0x60,0x09,0x13]

v_subrev_f32 v255, -|v255|, -|v255| row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x0b,0xff,0x6f,0xf5,0x30]

v_subrev_nc_u32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0x1b,0x00,0xff]

v_subrev_nc_u32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0xe4,0x00,0xff]

v_subrev_nc_u32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0x40,0x01,0xff]

v_subrev_nc_u32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0x41,0x01,0xff]

v_subrev_nc_u32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0x01,0x01,0xff]

v_subrev_nc_u32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0x0f,0x01,0xff]

v_subrev_nc_u32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0x11,0x01,0xff]

v_subrev_nc_u32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0x1f,0x01,0xff]

v_subrev_nc_u32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0x21,0x01,0xff]

v_subrev_nc_u32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0x2f,0x01,0xff]

v_subrev_nc_u32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0x50,0x01,0xff]

v_subrev_nc_u32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0x5f,0x01,0x01]

v_subrev_nc_u32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x4e,0x01,0x60,0x09,0x13]

v_subrev_nc_u32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x4f,0xff,0x6f,0x05,0x30]

v_xnor_b32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0x1b,0x00,0xff]

v_xnor_b32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0xe4,0x00,0xff]

v_xnor_b32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0x40,0x01,0xff]

v_xnor_b32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0x41,0x01,0xff]

v_xnor_b32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0x01,0x01,0xff]

v_xnor_b32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0x0f,0x01,0xff]

v_xnor_b32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0x11,0x01,0xff]

v_xnor_b32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0x1f,0x01,0xff]

v_xnor_b32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0x21,0x01,0xff]

v_xnor_b32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0x2f,0x01,0xff]

v_xnor_b32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0x50,0x01,0xff]

v_xnor_b32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0x5f,0x01,0x01]

v_xnor_b32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x3c,0x01,0x60,0x09,0x13]

v_xnor_b32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x3d,0xff,0x6f,0x05,0x30]

v_xor_b32 v5, v1, v2 quad_perm:[3,2,1,0]
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0x1b,0x00,0xff]

v_xor_b32 v5, v1, v2 quad_perm:[0,1,2,3]
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0xe4,0x00,0xff]

v_xor_b32 v5, v1, v2 row_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0x40,0x01,0xff]

v_xor_b32 v5, v1, v2 row_half_mirror
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0x41,0x01,0xff]

v_xor_b32 v5, v1, v2 row_shl:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0x01,0x01,0xff]

v_xor_b32 v5, v1, v2 row_shl:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0x0f,0x01,0xff]

v_xor_b32 v5, v1, v2 row_shr:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0x11,0x01,0xff]

v_xor_b32 v5, v1, v2 row_shr:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0x1f,0x01,0xff]

v_xor_b32 v5, v1, v2 row_ror:1
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0x21,0x01,0xff]

v_xor_b32 v5, v1, v2 row_ror:15
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0x2f,0x01,0xff]

v_xor_b32 v5, v1, v2 row_share:0 row_mask:0xf bank_mask:0xf
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0x50,0x01,0xff]

v_xor_b32 v5, v1, v2 row_share:15 row_mask:0x0 bank_mask:0x1
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0x5f,0x01,0x01]

v_xor_b32 v5, v1, v2 row_xmask:0 row_mask:0x1 bank_mask:0x3 bound_ctrl:1 fi:0
// GFX11: encoding: [0xfa,0x04,0x0a,0x3a,0x01,0x60,0x09,0x13]

v_xor_b32 v255, v255, v255 row_xmask:15 row_mask:0x3 bank_mask:0x0 bound_ctrl:0 fi:1
// GFX11: encoding: [0xfa,0xfe,0xff,0x3b,0xff,0x6f,0x05,0x30]
