// RUN: llvm-mc -triple i386-unknown-unknown --show-encoding %s | FileCheck %s

// CHECK: vcvtph2ps -485498096(%edx,%eax,4), %xmm1 
// CHECK: encoding: [0xc4,0xe2,0x79,0x13,0x8c,0x82,0x10,0xe3,0x0f,0xe3]        
vcvtph2ps -485498096(%edx,%eax,4), %xmm1 

// CHECK: vcvtph2ps 485498096(%edx,%eax,4), %xmm1 
// CHECK: encoding: [0xc4,0xe2,0x79,0x13,0x8c,0x82,0xf0,0x1c,0xf0,0x1c]        
vcvtph2ps 485498096(%edx,%eax,4), %xmm1 

// CHECK: vcvtph2ps -485498096(%edx,%eax,4), %ymm4 
// CHECK: encoding: [0xc4,0xe2,0x7d,0x13,0xa4,0x82,0x10,0xe3,0x0f,0xe3]        
vcvtph2ps -485498096(%edx,%eax,4), %ymm4 

// CHECK: vcvtph2ps 485498096(%edx,%eax,4), %ymm4 
// CHECK: encoding: [0xc4,0xe2,0x7d,0x13,0xa4,0x82,0xf0,0x1c,0xf0,0x1c]        
vcvtph2ps 485498096(%edx,%eax,4), %ymm4 

// CHECK: vcvtph2ps 485498096(%edx), %xmm1 
// CHECK: encoding: [0xc4,0xe2,0x79,0x13,0x8a,0xf0,0x1c,0xf0,0x1c]        
vcvtph2ps 485498096(%edx), %xmm1 

// CHECK: vcvtph2ps 485498096(%edx), %ymm4 
// CHECK: encoding: [0xc4,0xe2,0x7d,0x13,0xa2,0xf0,0x1c,0xf0,0x1c]        
vcvtph2ps 485498096(%edx), %ymm4 

// CHECK: vcvtph2ps 485498096, %xmm1 
// CHECK: encoding: [0xc4,0xe2,0x79,0x13,0x0d,0xf0,0x1c,0xf0,0x1c]        
vcvtph2ps 485498096, %xmm1 

// CHECK: vcvtph2ps 485498096, %ymm4 
// CHECK: encoding: [0xc4,0xe2,0x7d,0x13,0x25,0xf0,0x1c,0xf0,0x1c]        
vcvtph2ps 485498096, %ymm4 

// CHECK: vcvtph2ps 64(%edx,%eax), %xmm1 
// CHECK: encoding: [0xc4,0xe2,0x79,0x13,0x4c,0x02,0x40]        
vcvtph2ps 64(%edx,%eax), %xmm1 

// CHECK: vcvtph2ps 64(%edx,%eax), %ymm4 
// CHECK: encoding: [0xc4,0xe2,0x7d,0x13,0x64,0x02,0x40]        
vcvtph2ps 64(%edx,%eax), %ymm4 

// CHECK: vcvtph2ps (%edx), %xmm1 
// CHECK: encoding: [0xc4,0xe2,0x79,0x13,0x0a]        
vcvtph2ps (%edx), %xmm1 

// CHECK: vcvtph2ps (%edx), %ymm4 
// CHECK: encoding: [0xc4,0xe2,0x7d,0x13,0x22]        
vcvtph2ps (%edx), %ymm4 

// CHECK: vcvtph2ps %xmm1, %xmm1 
// CHECK: encoding: [0xc4,0xe2,0x79,0x13,0xc9]        
vcvtph2ps %xmm1, %xmm1 

// CHECK: vcvtph2ps %xmm1, %ymm4 
// CHECK: encoding: [0xc4,0xe2,0x7d,0x13,0xe1]        
vcvtph2ps %xmm1, %ymm4 

// CHECK: vcvtps2ph $0, %xmm1, -485498096(%edx,%eax,4) 
// CHECK: encoding: [0xc4,0xe3,0x79,0x1d,0x8c,0x82,0x10,0xe3,0x0f,0xe3,0x00]       
vcvtps2ph $0, %xmm1, -485498096(%edx,%eax,4) 

// CHECK: vcvtps2ph $0, %xmm1, 485498096(%edx,%eax,4) 
// CHECK: encoding: [0xc4,0xe3,0x79,0x1d,0x8c,0x82,0xf0,0x1c,0xf0,0x1c,0x00]       
vcvtps2ph $0, %xmm1, 485498096(%edx,%eax,4) 

// CHECK: vcvtps2ph $0, %xmm1, 485498096(%edx) 
// CHECK: encoding: [0xc4,0xe3,0x79,0x1d,0x8a,0xf0,0x1c,0xf0,0x1c,0x00]       
vcvtps2ph $0, %xmm1, 485498096(%edx) 

// CHECK: vcvtps2ph $0, %xmm1, 485498096 
// CHECK: encoding: [0xc4,0xe3,0x79,0x1d,0x0d,0xf0,0x1c,0xf0,0x1c,0x00]       
vcvtps2ph $0, %xmm1, 485498096 

// CHECK: vcvtps2ph $0, %xmm1, 64(%edx,%eax) 
// CHECK: encoding: [0xc4,0xe3,0x79,0x1d,0x4c,0x02,0x40,0x00]       
vcvtps2ph $0, %xmm1, 64(%edx,%eax) 

// CHECK: vcvtps2ph $0, %xmm1, (%edx) 
// CHECK: encoding: [0xc4,0xe3,0x79,0x1d,0x0a,0x00]       
vcvtps2ph $0, %xmm1, (%edx) 

// CHECK: vcvtps2ph $0, %xmm1, %xmm1 
// CHECK: encoding: [0xc4,0xe3,0x79,0x1d,0xc9,0x00]       
vcvtps2ph $0, %xmm1, %xmm1 

// CHECK: vcvtps2ph $0, %ymm4, -485498096(%edx,%eax,4) 
// CHECK: encoding: [0xc4,0xe3,0x7d,0x1d,0xa4,0x82,0x10,0xe3,0x0f,0xe3,0x00]       
vcvtps2ph $0, %ymm4, -485498096(%edx,%eax,4) 

// CHECK: vcvtps2ph $0, %ymm4, 485498096(%edx,%eax,4) 
// CHECK: encoding: [0xc4,0xe3,0x7d,0x1d,0xa4,0x82,0xf0,0x1c,0xf0,0x1c,0x00]       
vcvtps2ph $0, %ymm4, 485498096(%edx,%eax,4) 

// CHECK: vcvtps2ph $0, %ymm4, 485498096(%edx) 
// CHECK: encoding: [0xc4,0xe3,0x7d,0x1d,0xa2,0xf0,0x1c,0xf0,0x1c,0x00]       
vcvtps2ph $0, %ymm4, 485498096(%edx) 

// CHECK: vcvtps2ph $0, %ymm4, 485498096 
// CHECK: encoding: [0xc4,0xe3,0x7d,0x1d,0x25,0xf0,0x1c,0xf0,0x1c,0x00]       
vcvtps2ph $0, %ymm4, 485498096 

// CHECK: vcvtps2ph $0, %ymm4, 64(%edx,%eax) 
// CHECK: encoding: [0xc4,0xe3,0x7d,0x1d,0x64,0x02,0x40,0x00]       
vcvtps2ph $0, %ymm4, 64(%edx,%eax) 

// CHECK: vcvtps2ph $0, %ymm4, (%edx) 
// CHECK: encoding: [0xc4,0xe3,0x7d,0x1d,0x22,0x00]       
vcvtps2ph $0, %ymm4, (%edx) 

// CHECK: vcvtps2ph $0, %ymm4, %xmm1 
// CHECK: encoding: [0xc4,0xe3,0x7d,0x1d,0xe1,0x00]       
vcvtps2ph $0, %ymm4, %xmm1 

