# RUN: llvm-mc -triple x86_64 -show-encoding %s | FileCheck %s
# RUN: not llvm-mc -triple i386 -show-encoding %s 2>&1 | FileCheck %s --check-prefix=ERROR

# ERROR-COUNT-104: error:
# ERROR-NOT: error:
# CHECK: {evex}	andb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x80,0xe3,0x7b]
         {evex}	andb	$123, %bl
# CHECK: {nf}	andb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x80,0xe3,0x7b]
         {nf}	andb	$123, %bl
# CHECK: andb	$123, %bl, %cl
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0x80,0xe3,0x7b]
         andb	$123, %bl, %cl
# CHECK: {nf}	andb	$123, %bl, %cl
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0x80,0xe3,0x7b]
         {nf}	andb	$123, %bl, %cl
# CHECK: {evex}	andw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x83,0xe2,0x7b]
         {evex}	andw	$123, %dx
# CHECK: {nf}	andw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x83,0xe2,0x7b]
         {nf}	andw	$123, %dx
# CHECK: andw	$123, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x83,0xe2,0x7b]
         andw	$123, %dx, %ax
# CHECK: {nf}	andw	$123, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x83,0xe2,0x7b]
         {nf}	andw	$123, %dx, %ax
# CHECK: {evex}	andl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x83,0xe1,0x7b]
         {evex}	andl	$123, %ecx
# CHECK: {nf}	andl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x83,0xe1,0x7b]
         {nf}	andl	$123, %ecx
# CHECK: andl	$123, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x83,0xe1,0x7b]
         andl	$123, %ecx, %edx
# CHECK: {nf}	andl	$123, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x83,0xe1,0x7b]
         {nf}	andl	$123, %ecx, %edx
# CHECK: {evex}	andq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0xe1,0x7b]
         {evex}	andq	$123, %r9
# CHECK: {nf}	andq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0xe1,0x7b]
         {nf}	andq	$123, %r9
# CHECK: andq	$123, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x83,0xe1,0x7b]
         andq	$123, %r9, %r15
# CHECK: {nf}	andq	$123, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x83,0xe1,0x7b]
         {nf}	andq	$123, %r9, %r15
# CHECK: {evex}	andb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x80,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	andb	$123, 291(%r8,%rax,4)
# CHECK: {nf}	andb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x80,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	andb	$123, 291(%r8,%rax,4)
# CHECK: andb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0x80,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         andb	$123, 291(%r8,%rax,4), %bl
# CHECK: {nf}	andb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0x80,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	andb	$123, 291(%r8,%rax,4), %bl
# CHECK: {evex}	andw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	andw	$123, 291(%r8,%rax,4)
# CHECK: {nf}	andw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	andw	$123, 291(%r8,%rax,4)
# CHECK: andw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         andw	$123, 291(%r8,%rax,4), %dx
# CHECK: {nf}	andw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	andw	$123, 291(%r8,%rax,4), %dx
# CHECK: {evex}	andl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	andl	$123, 291(%r8,%rax,4)
# CHECK: {nf}	andl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	andl	$123, 291(%r8,%rax,4)
# CHECK: andl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         andl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	andl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	andl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	andq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	andq	$123, 291(%r8,%rax,4)
# CHECK: {nf}	andq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	andq	$123, 291(%r8,%rax,4)
# CHECK: andq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         andq	$123, 291(%r8,%rax,4), %r9
# CHECK: {nf}	andq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	andq	$123, 291(%r8,%rax,4), %r9
# CHECK: {evex}	andw	$1234, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x81,0xe2,0xd2,0x04]
         {evex}	andw	$1234, %dx
# CHECK: {nf}	andw	$1234, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x81,0xe2,0xd2,0x04]
         {nf}	andw	$1234, %dx
# CHECK: andw	$1234, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x81,0xe2,0xd2,0x04]
         andw	$1234, %dx, %ax
# CHECK: {nf}	andw	$1234, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x81,0xe2,0xd2,0x04]
         {nf}	andw	$1234, %dx, %ax
# CHECK: {evex}	andw	$1234, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {evex}	andw	$1234, 291(%r8,%rax,4)
# CHECK: {nf}	andw	$1234, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	andw	$1234, 291(%r8,%rax,4)
# CHECK: andw	$1234, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         andw	$1234, 291(%r8,%rax,4), %dx
# CHECK: {nf}	andw	$1234, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	andw	$1234, 291(%r8,%rax,4), %dx
# CHECK: {evex}	andl	$123456, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x81,0xe1,0x40,0xe2,0x01,0x00]
         {evex}	andl	$123456, %ecx
# CHECK: {nf}	andl	$123456, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x81,0xe1,0x40,0xe2,0x01,0x00]
         {nf}	andl	$123456, %ecx
# CHECK: andl	$123456, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x81,0xe1,0x40,0xe2,0x01,0x00]
         andl	$123456, %ecx, %edx
# CHECK: {nf}	andl	$123456, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x81,0xe1,0x40,0xe2,0x01,0x00]
         {nf}	andl	$123456, %ecx, %edx
# CHECK: {evex}	andq	$123456, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0xe1,0x40,0xe2,0x01,0x00]
         {evex}	andq	$123456, %r9
# CHECK: {nf}	andq	$123456, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0xe1,0x40,0xe2,0x01,0x00]
         {nf}	andq	$123456, %r9
# CHECK: andq	$123456, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x81,0xe1,0x40,0xe2,0x01,0x00]
         andq	$123456, %r9, %r15
# CHECK: {nf}	andq	$123456, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x81,0xe1,0x40,0xe2,0x01,0x00]
         {nf}	andq	$123456, %r9, %r15
# CHECK: {evex}	andl	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	andl	$123456, 291(%r8,%rax,4)
# CHECK: {nf}	andl	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	andl	$123456, 291(%r8,%rax,4)
# CHECK: andl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         andl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	andl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	andl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	andq	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	andq	$123456, 291(%r8,%rax,4)
# CHECK: {nf}	andq	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	andq	$123456, 291(%r8,%rax,4)
# CHECK: andq	$123456, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         andq	$123456, 291(%r8,%rax,4), %r9
# CHECK: {nf}	andq	$123456, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	andq	$123456, 291(%r8,%rax,4), %r9
# CHECK: {evex}	andb	%bl, %cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x20,0xd9]
         {evex}	andb	%bl, %cl
# CHECK: {nf}	andb	%bl, %cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x20,0xd9]
         {nf}	andb	%bl, %cl
# CHECK: andb	%bl, %cl, %r8b
# CHECK: encoding: [0x62,0xf4,0x3c,0x18,0x20,0xd9]
         andb	%bl, %cl, %r8b
# CHECK: {nf}	andb	%bl, %cl, %r8b
# CHECK: encoding: [0x62,0xf4,0x3c,0x1c,0x20,0xd9]
         {nf}	andb	%bl, %cl, %r8b
# CHECK: {evex}	andb	%bl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x20,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	andb	%bl, 291(%r8,%rax,4)
# CHECK: {nf}	andb	%bl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x20,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	andb	%bl, 291(%r8,%rax,4)
# CHECK: andb	%bl, 291(%r8,%rax,4), %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x20,0x9c,0x80,0x23,0x01,0x00,0x00]
         andb	%bl, 291(%r8,%rax,4), %cl
# CHECK: {nf}	andb	%bl, 291(%r8,%rax,4), %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x20,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	andb	%bl, 291(%r8,%rax,4), %cl
# CHECK: {evex}	andw	%dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x21,0xd0]
         {evex}	andw	%dx, %ax
# CHECK: {nf}	andw	%dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x21,0xd0]
         {nf}	andw	%dx, %ax
# CHECK: andw	%dx, %ax, %r9w
# CHECK: encoding: [0x62,0xf4,0x35,0x18,0x21,0xd0]
         andw	%dx, %ax, %r9w
# CHECK: {nf}	andw	%dx, %ax, %r9w
# CHECK: encoding: [0x62,0xf4,0x35,0x1c,0x21,0xd0]
         {nf}	andw	%dx, %ax, %r9w
# CHECK: {evex}	andw	%dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x21,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	andw	%dx, 291(%r8,%rax,4)
# CHECK: {nf}	andw	%dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x21,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	andw	%dx, 291(%r8,%rax,4)
# CHECK: andw	%dx, 291(%r8,%rax,4), %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x21,0x94,0x80,0x23,0x01,0x00,0x00]
         andw	%dx, 291(%r8,%rax,4), %ax
# CHECK: {nf}	andw	%dx, 291(%r8,%rax,4), %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x21,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	andw	%dx, 291(%r8,%rax,4), %ax
# CHECK: {evex}	andl	%ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x21,0xca]
         {evex}	andl	%ecx, %edx
# CHECK: {nf}	andl	%ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x21,0xca]
         {nf}	andl	%ecx, %edx
# CHECK: andl	%ecx, %edx, %r10d
# CHECK: encoding: [0x62,0xf4,0x2c,0x18,0x21,0xca]
         andl	%ecx, %edx, %r10d
# CHECK: {nf}	andl	%ecx, %edx, %r10d
# CHECK: encoding: [0x62,0xf4,0x2c,0x1c,0x21,0xca]
         {nf}	andl	%ecx, %edx, %r10d
# CHECK: {evex}	andl	%ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	andl	%ecx, 291(%r8,%rax,4)
# CHECK: {nf}	andl	%ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	andl	%ecx, 291(%r8,%rax,4)
# CHECK: andl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         andl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: {nf}	andl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	andl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: {evex}	andq	%r9, %r15
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x21,0xcf]
         {evex}	andq	%r9, %r15
# CHECK: {nf}	andq	%r9, %r15
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x21,0xcf]
         {nf}	andq	%r9, %r15
# CHECK: andq	%r9, %r15, %r11
# CHECK: encoding: [0x62,0x54,0xa4,0x18,0x21,0xcf]
         andq	%r9, %r15, %r11
# CHECK: {nf}	andq	%r9, %r15, %r11
# CHECK: encoding: [0x62,0x54,0xa4,0x1c,0x21,0xcf]
         {nf}	andq	%r9, %r15, %r11
# CHECK: {evex}	andq	%r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	andq	%r9, 291(%r8,%rax,4)
# CHECK: {nf}	andq	%r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	andq	%r9, 291(%r8,%rax,4)
# CHECK: andq	%r9, 291(%r8,%rax,4), %r15
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         andq	%r9, 291(%r8,%rax,4), %r15
# CHECK: {nf}	andq	%r9, 291(%r8,%rax,4), %r15
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	andq	%r9, 291(%r8,%rax,4), %r15
# CHECK: {evex}	andb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x22,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	andb	291(%r8,%rax,4), %bl
# CHECK: {nf}	andb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x22,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	andb	291(%r8,%rax,4), %bl
# CHECK: andb	291(%r8,%rax,4), %bl, %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x22,0x9c,0x80,0x23,0x01,0x00,0x00]
         andb	291(%r8,%rax,4), %bl, %cl
# CHECK: {nf}	andb	291(%r8,%rax,4), %bl, %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x22,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	andb	291(%r8,%rax,4), %bl, %cl
# CHECK: {evex}	andw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x23,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	andw	291(%r8,%rax,4), %dx
# CHECK: {nf}	andw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x23,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	andw	291(%r8,%rax,4), %dx
# CHECK: andw	291(%r8,%rax,4), %dx, %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x23,0x94,0x80,0x23,0x01,0x00,0x00]
         andw	291(%r8,%rax,4), %dx, %ax
# CHECK: {nf}	andw	291(%r8,%rax,4), %dx, %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x23,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	andw	291(%r8,%rax,4), %dx, %ax
# CHECK: {evex}	andl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	andl	291(%r8,%rax,4), %ecx
# CHECK: {nf}	andl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	andl	291(%r8,%rax,4), %ecx
# CHECK: andl	291(%r8,%rax,4), %ecx, %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         andl	291(%r8,%rax,4), %ecx, %edx
# CHECK: {nf}	andl	291(%r8,%rax,4), %ecx, %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	andl	291(%r8,%rax,4), %ecx, %edx
# CHECK: {evex}	andq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	andq	291(%r8,%rax,4), %r9
# CHECK: {nf}	andq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	andq	291(%r8,%rax,4), %r9
# CHECK: andq	291(%r8,%rax,4), %r9, %r15
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         andq	291(%r8,%rax,4), %r9, %r15
# CHECK: {nf}	andq	291(%r8,%rax,4), %r9, %r15
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	andq	291(%r8,%rax,4), %r9, %r15
