# RUN: llvm-mc -triple x86_64 -show-encoding -x86-asm-syntax=intel -output-asm-variant=1 %s | FileCheck %s

# CHECK: {evex}	dec	bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xfe,0xcb]
         {evex}	dec	bl
# CHECK: {nf}	dec	bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xfe,0xcb]
         {nf}	dec	bl
# CHECK: dec	bl, bl
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xfe,0xcb]
         dec	bl, bl
# CHECK: {nf}	dec	bl, bl
# CHECK: encoding: [0x62,0xf4,0x64,0x1c,0xfe,0xcb]
         {nf}	dec	bl, bl
# CHECK: {evex}	dec	dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xff,0xca]
         {evex}	dec	dx
# CHECK: {nf}	dec	dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xff,0xca]
         {nf}	dec	dx
# CHECK: dec	dx, dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xff,0xca]
         dec	dx, dx
# CHECK: {nf}	dec	dx, dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xff,0xca]
         {nf}	dec	dx, dx
# CHECK: {evex}	dec	ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xff,0xc9]
         {evex}	dec	ecx
# CHECK: {nf}	dec	ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xff,0xc9]
         {nf}	dec	ecx
# CHECK: dec	ecx, ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xff,0xc9]
         dec	ecx, ecx
# CHECK: {nf}	dec	ecx, ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xff,0xc9]
         {nf}	dec	ecx, ecx
# CHECK: {evex}	dec	r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xff,0xc9]
         {evex}	dec	r9
# CHECK: {nf}	dec	r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xff,0xc9]
         {nf}	dec	r9
# CHECK: dec	r9, r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xff,0xc9]
         dec	r9, r9
# CHECK: {nf}	dec	r9, r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xff,0xc9]
         {nf}	dec	r9, r9
# CHECK: {evex}	dec	byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xfe,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	dec	byte ptr [r8 + 4*rax + 291]
# CHECK: {nf}	dec	byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xfe,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	dec	byte ptr [r8 + 4*rax + 291]
# CHECK: dec	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xfe,0x8c,0x80,0x23,0x01,0x00,0x00]
         dec	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {nf}	dec	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xfe,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	dec	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {evex}	dec	word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	dec	word ptr [r8 + 4*rax + 291]
# CHECK: {nf}	dec	word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	dec	word ptr [r8 + 4*rax + 291]
# CHECK: dec	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         dec	dx, word ptr [r8 + 4*rax + 291]
# CHECK: {nf}	dec	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	dec	dx, word ptr [r8 + 4*rax + 291]
# CHECK: {evex}	dec	dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	dec	dword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	dec	dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	dec	dword ptr [r8 + 4*rax + 291]
# CHECK: dec	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         dec	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	dec	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	dec	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {evex}	dec	qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	dec	qword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	dec	qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	dec	qword ptr [r8 + 4*rax + 291]
# CHECK: dec	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         dec	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	dec	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	dec	r9, qword ptr [r8 + 4*rax + 291]
