# RUN: llvm-mc -triple x86_64 -show-encoding -x86-asm-syntax=intel -output-asm-variant=1 %s | FileCheck %s

# CHECK: {evex}	neg	bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xf6,0xdb]
         {evex}	neg	bl
# CHECK: {nf}	neg	bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xf6,0xdb]
         {nf}	neg	bl
# CHECK: neg	bl, bl
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xf6,0xdb]
         neg	bl, bl
# CHECK: {nf}	neg	bl, bl
# CHECK: encoding: [0x62,0xf4,0x64,0x1c,0xf6,0xdb]
         {nf}	neg	bl, bl
# CHECK: {evex}	neg	dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xf7,0xda]
         {evex}	neg	dx
# CHECK: {nf}	neg	dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xf7,0xda]
         {nf}	neg	dx
# CHECK: neg	dx, dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xf7,0xda]
         neg	dx, dx
# CHECK: {nf}	neg	dx, dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xf7,0xda]
         {nf}	neg	dx, dx
# CHECK: {evex}	neg	ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xf7,0xd9]
         {evex}	neg	ecx
# CHECK: {nf}	neg	ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xf7,0xd9]
         {nf}	neg	ecx
# CHECK: neg	ecx, ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xf7,0xd9]
         neg	ecx, ecx
# CHECK: {nf}	neg	ecx, ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xf7,0xd9]
         {nf}	neg	ecx, ecx
# CHECK: {evex}	neg	r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xf7,0xd9]
         {evex}	neg	r9
# CHECK: {nf}	neg	r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xf7,0xd9]
         {nf}	neg	r9
# CHECK: neg	r9, r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xf7,0xd9]
         neg	r9, r9
# CHECK: {nf}	neg	r9, r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xf7,0xd9]
         {nf}	neg	r9, r9
# CHECK: {evex}	neg	byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xf6,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	neg	byte ptr [r8 + 4*rax + 291]
# CHECK: {nf}	neg	byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xf6,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	neg	byte ptr [r8 + 4*rax + 291]
# CHECK: neg	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xf6,0x9c,0x80,0x23,0x01,0x00,0x00]
         neg	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {nf}	neg	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xf6,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	neg	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {evex}	neg	word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	neg	word ptr [r8 + 4*rax + 291]
# CHECK: {nf}	neg	word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	neg	word ptr [r8 + 4*rax + 291]
# CHECK: neg	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         neg	dx, word ptr [r8 + 4*rax + 291]
# CHECK: {nf}	neg	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	neg	dx, word ptr [r8 + 4*rax + 291]
# CHECK: {evex}	neg	dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	neg	dword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	neg	dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	neg	dword ptr [r8 + 4*rax + 291]
# CHECK: neg	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         neg	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	neg	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	neg	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {evex}	neg	qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	neg	qword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	neg	qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	neg	qword ptr [r8 + 4*rax + 291]
# CHECK: neg	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         neg	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	neg	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	neg	r9, qword ptr [r8 + 4*rax + 291]
