# RUN: llvm-mc -triple x86_64 -show-encoding -x86-asm-syntax=intel -output-asm-variant=1 %s | FileCheck %s

# CHECK: {evex}	rcl	bl, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xc0,0xd3,0x7b]
         {evex}	rcl	bl, 123
# CHECK: rcl	bl, bl, 123
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xc0,0xd3,0x7b]
         rcl	bl, bl, 123
# CHECK: {evex}	rcl	dx, 123
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xc1,0xd2,0x7b]
         {evex}	rcl	dx, 123
# CHECK: rcl	dx, dx, 123
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xc1,0xd2,0x7b]
         rcl	dx, dx, 123
# CHECK: {evex}	rcl	ecx, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xc1,0xd1,0x7b]
         {evex}	rcl	ecx, 123
# CHECK: rcl	ecx, ecx, 123
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xc1,0xd1,0x7b]
         rcl	ecx, ecx, 123
# CHECK: {evex}	rcl	r9, 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xc1,0xd1,0x7b]
         {evex}	rcl	r9, 123
# CHECK: rcl	r9, r9, 123
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xc1,0xd1,0x7b]
         rcl	r9, r9, 123
# CHECK: {evex}	rcl	byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xc0,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	rcl	byte ptr [r8 + 4*rax + 291], 123
# CHECK: rcl	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xc0,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         rcl	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	rcl	word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xc1,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	rcl	word ptr [r8 + 4*rax + 291], 123
# CHECK: rcl	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xc1,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         rcl	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	rcl	dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xc1,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	rcl	dword ptr [r8 + 4*rax + 291], 123
# CHECK: rcl	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xc1,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         rcl	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	rcl	qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xc1,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	rcl	qword ptr [r8 + 4*rax + 291], 123
# CHECK: rcl	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xc1,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         rcl	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	rcl	bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd0,0xd3]
         {evex}	rcl	bl
# CHECK: {evex}	rcl	bl, cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd2,0xd3]
         {evex}	rcl	bl, cl
# CHECK: rcl	bl, bl, cl
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xd2,0xd3]
         rcl	bl, bl, cl
# CHECK: {evex}	rcl	dx, cl
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xd3,0xd2]
         {evex}	rcl	dx, cl
# CHECK: rcl	dx, dx, cl
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xd3,0xd2]
         rcl	dx, dx, cl
# CHECK: {evex}	rcl	ecx, cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd3,0xd1]
         {evex}	rcl	ecx, cl
# CHECK: rcl	ecx, ecx, cl
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xd3,0xd1]
         rcl	ecx, ecx, cl
# CHECK: {evex}	rcl	r9, cl
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd3,0xd1]
         {evex}	rcl	r9, cl
# CHECK: rcl	r9, r9, cl
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd3,0xd1]
         rcl	r9, r9, cl
# CHECK: {evex}	rcl	byte ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd2,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	rcl	byte ptr [r8 + 4*rax + 291], cl
# CHECK: rcl	bl, byte ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xd2,0x94,0x80,0x23,0x01,0x00,0x00]
         rcl	bl, byte ptr [r8 + 4*rax + 291], cl
# CHECK: {evex}	rcl	word ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xd3,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	rcl	word ptr [r8 + 4*rax + 291], cl
# CHECK: rcl	dx, word ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xd3,0x94,0x80,0x23,0x01,0x00,0x00]
         rcl	dx, word ptr [r8 + 4*rax + 291], cl
# CHECK: {evex}	rcl	dword ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd3,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	rcl	dword ptr [r8 + 4*rax + 291], cl
# CHECK: rcl	ecx, dword ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xd3,0x94,0x80,0x23,0x01,0x00,0x00]
         rcl	ecx, dword ptr [r8 + 4*rax + 291], cl
# CHECK: {evex}	rcl	qword ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd3,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	rcl	qword ptr [r8 + 4*rax + 291], cl
# CHECK: rcl	r9, qword ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd3,0x94,0x80,0x23,0x01,0x00,0x00]
         rcl	r9, qword ptr [r8 + 4*rax + 291], cl
# CHECK: {evex}	rcl	dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xd1,0xd2]
         {evex}	rcl	dx
# CHECK: rcl	dx, dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xd1,0xd2]
         rcl	dx, dx
# CHECK: {evex}	rcl	ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd1,0xd1]
         {evex}	rcl	ecx
# CHECK: rcl	ecx, ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xd1,0xd1]
         rcl	ecx, ecx
# CHECK: {evex}	rcl	r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd1,0xd1]
         {evex}	rcl	r9
# CHECK: rcl	r9, r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd1,0xd1]
         rcl	r9, r9
# CHECK: {evex}	rcl	byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd0,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	rcl	byte ptr [r8 + 4*rax + 291]
# CHECK: rcl	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xd0,0x94,0x80,0x23,0x01,0x00,0x00]
         rcl	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {evex}	rcl	word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xd1,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	rcl	word ptr [r8 + 4*rax + 291]
# CHECK: rcl	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xd1,0x94,0x80,0x23,0x01,0x00,0x00]
         rcl	dx, word ptr [r8 + 4*rax + 291]
# CHECK: {evex}	rcl	dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd1,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	rcl	dword ptr [r8 + 4*rax + 291]
# CHECK: rcl	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xd1,0x94,0x80,0x23,0x01,0x00,0x00]
         rcl	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {evex}	rcl	qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd1,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	rcl	qword ptr [r8 + 4*rax + 291]
# CHECK: rcl	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd1,0x94,0x80,0x23,0x01,0x00,0x00]
         rcl	r9, qword ptr [r8 + 4*rax + 291]
