# RUN: llvm-mc -triple x86_64 -show-encoding %s | FileCheck %s
# RUN: not llvm-mc -triple i386 -show-encoding %s 2>&1 | FileCheck %s --check-prefix=ERROR

# ERROR-COUNT-94: error:
# ERROR-NOT: error:
# CHECK: {evex}	rorb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xc0,0xcb,0x7b]
         {evex}	rorb	$123, %bl
# CHECK: {nf}	rorb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xc0,0xcb,0x7b]
         {nf}	rorb	$123, %bl
# CHECK: rorb	$123, %bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xc0,0xcb,0x7b]
         rorb	$123, %bl, %bl
# CHECK: {nf}	rorb	$123, %bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x1c,0xc0,0xcb,0x7b]
         {nf}	rorb	$123, %bl, %bl
# CHECK: {evex}	rorw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xc1,0xca,0x7b]
         {evex}	rorw	$123, %dx
# CHECK: {nf}	rorw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xc1,0xca,0x7b]
         {nf}	rorw	$123, %dx
# CHECK: rorw	$123, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xc1,0xca,0x7b]
         rorw	$123, %dx, %dx
# CHECK: {nf}	rorw	$123, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xc1,0xca,0x7b]
         {nf}	rorw	$123, %dx, %dx
# CHECK: {evex}	rorl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xc1,0xc9,0x7b]
         {evex}	rorl	$123, %ecx
# CHECK: {nf}	rorl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xc1,0xc9,0x7b]
         {nf}	rorl	$123, %ecx
# CHECK: rorl	$123, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xc1,0xc9,0x7b]
         rorl	$123, %ecx, %ecx
# CHECK: {nf}	rorl	$123, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xc1,0xc9,0x7b]
         {nf}	rorl	$123, %ecx, %ecx
# CHECK: {evex}	rorq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xc1,0xc9,0x7b]
         {evex}	rorq	$123, %r9
# CHECK: {nf}	rorq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xc1,0xc9,0x7b]
         {nf}	rorq	$123, %r9
# CHECK: rorq	$123, %r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xc1,0xc9,0x7b]
         rorq	$123, %r9, %r9
# CHECK: {nf}	rorq	$123, %r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xc1,0xc9,0x7b]
         {nf}	rorq	$123, %r9, %r9
# CHECK: {evex}	rorb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xc0,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	rorb	$123, 291(%r8,%rax,4)
# CHECK: {nf}	rorb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xc0,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	rorb	$123, 291(%r8,%rax,4)
# CHECK: rorb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xc0,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         rorb	$123, 291(%r8,%rax,4), %bl
# CHECK: {nf}	rorb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xc0,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	rorb	$123, 291(%r8,%rax,4), %bl
# CHECK: {evex}	rorw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xc1,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	rorw	$123, 291(%r8,%rax,4)
# CHECK: {nf}	rorw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xc1,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	rorw	$123, 291(%r8,%rax,4)
# CHECK: rorw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xc1,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         rorw	$123, 291(%r8,%rax,4), %dx
# CHECK: {nf}	rorw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xc1,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	rorw	$123, 291(%r8,%rax,4), %dx
# CHECK: {evex}	rorl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xc1,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	rorl	$123, 291(%r8,%rax,4)
# CHECK: {nf}	rorl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xc1,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	rorl	$123, 291(%r8,%rax,4)
# CHECK: rorl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xc1,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         rorl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	rorl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xc1,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	rorl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	rorq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xc1,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	rorq	$123, 291(%r8,%rax,4)
# CHECK: {nf}	rorq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xc1,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	rorq	$123, 291(%r8,%rax,4)
# CHECK: rorq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xc1,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         rorq	$123, 291(%r8,%rax,4), %r9
# CHECK: {nf}	rorq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xc1,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	rorq	$123, 291(%r8,%rax,4), %r9
# CHECK: {evex}	rorb	%bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd0,0xcb]
         {evex}	rorb	%bl
# CHECK: {nf}	rorb	%bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xd0,0xcb]
         {nf}	rorb	%bl
# CHECK: {evex}	rorb	%cl, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd2,0xcb]
         {evex}	rorb	%cl, %bl
# CHECK: {nf}	rorb	%cl, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xd2,0xcb]
         {nf}	rorb	%cl, %bl
# CHECK: rorb	%cl, %bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xd2,0xcb]
         rorb	%cl, %bl, %bl
# CHECK: {nf}	rorb	%cl, %bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x1c,0xd2,0xcb]
         {nf}	rorb	%cl, %bl, %bl
# CHECK: {evex}	rorw	%cl, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xd3,0xca]
         {evex}	rorw	%cl, %dx
# CHECK: {nf}	rorw	%cl, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xd3,0xca]
         {nf}	rorw	%cl, %dx
# CHECK: rorw	%cl, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xd3,0xca]
         rorw	%cl, %dx, %dx
# CHECK: {nf}	rorw	%cl, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xd3,0xca]
         {nf}	rorw	%cl, %dx, %dx
# CHECK: {evex}	rorl	%cl, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd3,0xc9]
         {evex}	rorl	%cl, %ecx
# CHECK: {nf}	rorl	%cl, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xd3,0xc9]
         {nf}	rorl	%cl, %ecx
# CHECK: rorl	%cl, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xd3,0xc9]
         rorl	%cl, %ecx, %ecx
# CHECK: {nf}	rorl	%cl, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xd3,0xc9]
         {nf}	rorl	%cl, %ecx, %ecx
# CHECK: {evex}	rorq	%cl, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd3,0xc9]
         {evex}	rorq	%cl, %r9
# CHECK: {nf}	rorq	%cl, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xd3,0xc9]
         {nf}	rorq	%cl, %r9
# CHECK: rorq	%cl, %r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd3,0xc9]
         rorq	%cl, %r9, %r9
# CHECK: {nf}	rorq	%cl, %r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xd3,0xc9]
         {nf}	rorq	%cl, %r9, %r9
# CHECK: {evex}	rorb	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd2,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	rorb	%cl, 291(%r8,%rax,4)
# CHECK: {nf}	rorb	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xd2,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorb	%cl, 291(%r8,%rax,4)
# CHECK: rorb	%cl, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xd2,0x8c,0x80,0x23,0x01,0x00,0x00]
         rorb	%cl, 291(%r8,%rax,4), %bl
# CHECK: {nf}	rorb	%cl, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xd2,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorb	%cl, 291(%r8,%rax,4), %bl
# CHECK: {evex}	rorw	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xd3,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	rorw	%cl, 291(%r8,%rax,4)
# CHECK: {nf}	rorw	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xd3,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorw	%cl, 291(%r8,%rax,4)
# CHECK: rorw	%cl, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xd3,0x8c,0x80,0x23,0x01,0x00,0x00]
         rorw	%cl, 291(%r8,%rax,4), %dx
# CHECK: {nf}	rorw	%cl, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xd3,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorw	%cl, 291(%r8,%rax,4), %dx
# CHECK: {evex}	rorl	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd3,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	rorl	%cl, 291(%r8,%rax,4)
# CHECK: {nf}	rorl	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xd3,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorl	%cl, 291(%r8,%rax,4)
# CHECK: rorl	%cl, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xd3,0x8c,0x80,0x23,0x01,0x00,0x00]
         rorl	%cl, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	rorl	%cl, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xd3,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorl	%cl, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	rorq	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd3,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	rorq	%cl, 291(%r8,%rax,4)
# CHECK: {nf}	rorq	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xd3,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorq	%cl, 291(%r8,%rax,4)
# CHECK: rorq	%cl, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd3,0x8c,0x80,0x23,0x01,0x00,0x00]
         rorq	%cl, 291(%r8,%rax,4), %r9
# CHECK: {nf}	rorq	%cl, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xd3,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorq	%cl, 291(%r8,%rax,4), %r9
# CHECK: {evex}	rorw	%dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xd1,0xca]
         {evex}	rorw	%dx
# CHECK: {nf}	rorw	%dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xd1,0xca]
         {nf}	rorw	%dx
# CHECK: rorw	%dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xd1,0xca]
         rorw	%dx, %dx
# CHECK: {nf}	rorw	%dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xd1,0xca]
         {nf}	rorw	%dx, %dx
# CHECK: {evex}	rorl	%ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd1,0xc9]
         {evex}	rorl	%ecx
# CHECK: {nf}	rorl	%ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xd1,0xc9]
         {nf}	rorl	%ecx
# CHECK: rorl	%ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xd1,0xc9]
         rorl	%ecx, %ecx
# CHECK: {nf}	rorl	%ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xd1,0xc9]
         {nf}	rorl	%ecx, %ecx
# CHECK: {evex}	rorq	%r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd1,0xc9]
         {evex}	rorq	%r9
# CHECK: {nf}	rorq	%r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xd1,0xc9]
         {nf}	rorq	%r9
# CHECK: rorq	%r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd1,0xc9]
         rorq	%r9, %r9
# CHECK: {nf}	rorq	%r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xd1,0xc9]
         {nf}	rorq	%r9, %r9
# CHECK: {evex}	rorb	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd0,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	rorb	291(%r8,%rax,4)
# CHECK: {nf}	rorb	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xd0,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorb	291(%r8,%rax,4)
# CHECK: rorb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xd0,0x8c,0x80,0x23,0x01,0x00,0x00]
         rorb	291(%r8,%rax,4), %bl
# CHECK: {nf}	rorb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xd0,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorb	291(%r8,%rax,4), %bl
# CHECK: {evex}	rorw	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xd1,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	rorw	291(%r8,%rax,4)
# CHECK: {nf}	rorw	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xd1,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorw	291(%r8,%rax,4)
# CHECK: rorw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xd1,0x8c,0x80,0x23,0x01,0x00,0x00]
         rorw	291(%r8,%rax,4), %dx
# CHECK: {nf}	rorw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xd1,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorw	291(%r8,%rax,4), %dx
# CHECK: {evex}	rorl	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd1,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	rorl	291(%r8,%rax,4)
# CHECK: {nf}	rorl	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xd1,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorl	291(%r8,%rax,4)
# CHECK: rorl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xd1,0x8c,0x80,0x23,0x01,0x00,0x00]
         rorl	291(%r8,%rax,4), %ecx
# CHECK: {nf}	rorl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xd1,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorl	291(%r8,%rax,4), %ecx
# CHECK: {evex}	rorq	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd1,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	rorq	291(%r8,%rax,4)
# CHECK: {nf}	rorq	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xd1,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorq	291(%r8,%rax,4)
# CHECK: rorq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd1,0x8c,0x80,0x23,0x01,0x00,0x00]
         rorq	291(%r8,%rax,4), %r9
# CHECK: {nf}	rorq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xd1,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	rorq	291(%r8,%rax,4), %r9
