# RUN: llvm-mc -triple x86_64 -show-encoding %s | FileCheck %s
# RUN: not llvm-mc -triple i386 -show-encoding %s 2>&1 | FileCheck %s --check-prefix=ERROR

# ERROR-COUNT-104: error:
# ERROR-NOT: error:
# CHECK: {evex}	xorb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x80,0xf3,0x7b]
         {evex}	xorb	$123, %bl
# CHECK: {nf}	xorb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x80,0xf3,0x7b]
         {nf}	xorb	$123, %bl
# CHECK: xorb	$123, %bl, %cl
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0x80,0xf3,0x7b]
         xorb	$123, %bl, %cl
# CHECK: {nf}	xorb	$123, %bl, %cl
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0x80,0xf3,0x7b]
         {nf}	xorb	$123, %bl, %cl
# CHECK: {evex}	xorw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x83,0xf2,0x7b]
         {evex}	xorw	$123, %dx
# CHECK: {nf}	xorw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x83,0xf2,0x7b]
         {nf}	xorw	$123, %dx
# CHECK: xorw	$123, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x83,0xf2,0x7b]
         xorw	$123, %dx, %ax
# CHECK: {nf}	xorw	$123, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x83,0xf2,0x7b]
         {nf}	xorw	$123, %dx, %ax
# CHECK: {evex}	xorl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x83,0xf1,0x7b]
         {evex}	xorl	$123, %ecx
# CHECK: {nf}	xorl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x83,0xf1,0x7b]
         {nf}	xorl	$123, %ecx
# CHECK: xorl	$123, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x83,0xf1,0x7b]
         xorl	$123, %ecx, %edx
# CHECK: {nf}	xorl	$123, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x83,0xf1,0x7b]
         {nf}	xorl	$123, %ecx, %edx
# CHECK: {evex}	xorq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0xf1,0x7b]
         {evex}	xorq	$123, %r9
# CHECK: {nf}	xorq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0xf1,0x7b]
         {nf}	xorq	$123, %r9
# CHECK: xorq	$123, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x83,0xf1,0x7b]
         xorq	$123, %r9, %r15
# CHECK: {nf}	xorq	$123, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x83,0xf1,0x7b]
         {nf}	xorq	$123, %r9, %r15
# CHECK: {evex}	xorb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x80,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	xorb	$123, 291(%r8,%rax,4)
# CHECK: {nf}	xorb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x80,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	xorb	$123, 291(%r8,%rax,4)
# CHECK: xorb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0x80,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         xorb	$123, 291(%r8,%rax,4), %bl
# CHECK: {nf}	xorb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0x80,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	xorb	$123, 291(%r8,%rax,4), %bl
# CHECK: {evex}	xorw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x83,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	xorw	$123, 291(%r8,%rax,4)
# CHECK: {nf}	xorw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x83,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	xorw	$123, 291(%r8,%rax,4)
# CHECK: xorw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x83,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         xorw	$123, 291(%r8,%rax,4), %dx
# CHECK: {nf}	xorw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x83,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	xorw	$123, 291(%r8,%rax,4), %dx
# CHECK: {evex}	xorl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x83,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	xorl	$123, 291(%r8,%rax,4)
# CHECK: {nf}	xorl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x83,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	xorl	$123, 291(%r8,%rax,4)
# CHECK: xorl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x83,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         xorl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	xorl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x83,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	xorl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	xorq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	xorq	$123, 291(%r8,%rax,4)
# CHECK: {nf}	xorq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	xorq	$123, 291(%r8,%rax,4)
# CHECK: xorq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x83,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         xorq	$123, 291(%r8,%rax,4), %r9
# CHECK: {nf}	xorq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x83,0xb4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	xorq	$123, 291(%r8,%rax,4), %r9
# CHECK: {evex}	xorw	$1234, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x81,0xf2,0xd2,0x04]
         {evex}	xorw	$1234, %dx
# CHECK: {nf}	xorw	$1234, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x81,0xf2,0xd2,0x04]
         {nf}	xorw	$1234, %dx
# CHECK: xorw	$1234, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x81,0xf2,0xd2,0x04]
         xorw	$1234, %dx, %ax
# CHECK: {nf}	xorw	$1234, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x81,0xf2,0xd2,0x04]
         {nf}	xorw	$1234, %dx, %ax
# CHECK: {evex}	xorw	$1234, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x81,0xb4,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {evex}	xorw	$1234, 291(%r8,%rax,4)
# CHECK: {nf}	xorw	$1234, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x81,0xb4,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	xorw	$1234, 291(%r8,%rax,4)
# CHECK: xorw	$1234, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x81,0xb4,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         xorw	$1234, 291(%r8,%rax,4), %dx
# CHECK: {nf}	xorw	$1234, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x81,0xb4,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	xorw	$1234, 291(%r8,%rax,4), %dx
# CHECK: {evex}	xorl	$123456, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x81,0xf1,0x40,0xe2,0x01,0x00]
         {evex}	xorl	$123456, %ecx
# CHECK: {nf}	xorl	$123456, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x81,0xf1,0x40,0xe2,0x01,0x00]
         {nf}	xorl	$123456, %ecx
# CHECK: xorl	$123456, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x81,0xf1,0x40,0xe2,0x01,0x00]
         xorl	$123456, %ecx, %edx
# CHECK: {nf}	xorl	$123456, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x81,0xf1,0x40,0xe2,0x01,0x00]
         {nf}	xorl	$123456, %ecx, %edx
# CHECK: {evex}	xorq	$123456, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0xf1,0x40,0xe2,0x01,0x00]
         {evex}	xorq	$123456, %r9
# CHECK: {nf}	xorq	$123456, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0xf1,0x40,0xe2,0x01,0x00]
         {nf}	xorq	$123456, %r9
# CHECK: xorq	$123456, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x81,0xf1,0x40,0xe2,0x01,0x00]
         xorq	$123456, %r9, %r15
# CHECK: {nf}	xorq	$123456, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x81,0xf1,0x40,0xe2,0x01,0x00]
         {nf}	xorq	$123456, %r9, %r15
# CHECK: {evex}	xorl	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x81,0xb4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	xorl	$123456, 291(%r8,%rax,4)
# CHECK: {nf}	xorl	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x81,0xb4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	xorl	$123456, 291(%r8,%rax,4)
# CHECK: xorl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x81,0xb4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         xorl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	xorl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x81,0xb4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	xorl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	xorq	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0xb4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	xorq	$123456, 291(%r8,%rax,4)
# CHECK: {nf}	xorq	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0xb4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	xorq	$123456, 291(%r8,%rax,4)
# CHECK: xorq	$123456, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x81,0xb4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         xorq	$123456, 291(%r8,%rax,4), %r9
# CHECK: {nf}	xorq	$123456, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x81,0xb4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	xorq	$123456, 291(%r8,%rax,4), %r9
# CHECK: {evex}	xorb	%bl, %cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x30,0xd9]
         {evex}	xorb	%bl, %cl
# CHECK: {nf}	xorb	%bl, %cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x30,0xd9]
         {nf}	xorb	%bl, %cl
# CHECK: xorb	%bl, %cl, %r8b
# CHECK: encoding: [0x62,0xf4,0x3c,0x18,0x30,0xd9]
         xorb	%bl, %cl, %r8b
# CHECK: {nf}	xorb	%bl, %cl, %r8b
# CHECK: encoding: [0x62,0xf4,0x3c,0x1c,0x30,0xd9]
         {nf}	xorb	%bl, %cl, %r8b
# CHECK: {evex}	xorb	%bl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x30,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	xorb	%bl, 291(%r8,%rax,4)
# CHECK: {nf}	xorb	%bl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x30,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorb	%bl, 291(%r8,%rax,4)
# CHECK: xorb	%bl, 291(%r8,%rax,4), %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x30,0x9c,0x80,0x23,0x01,0x00,0x00]
         xorb	%bl, 291(%r8,%rax,4), %cl
# CHECK: {nf}	xorb	%bl, 291(%r8,%rax,4), %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x30,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorb	%bl, 291(%r8,%rax,4), %cl
# CHECK: {evex}	xorw	%dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x31,0xd0]
         {evex}	xorw	%dx, %ax
# CHECK: {nf}	xorw	%dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x31,0xd0]
         {nf}	xorw	%dx, %ax
# CHECK: xorw	%dx, %ax, %r9w
# CHECK: encoding: [0x62,0xf4,0x35,0x18,0x31,0xd0]
         xorw	%dx, %ax, %r9w
# CHECK: {nf}	xorw	%dx, %ax, %r9w
# CHECK: encoding: [0x62,0xf4,0x35,0x1c,0x31,0xd0]
         {nf}	xorw	%dx, %ax, %r9w
# CHECK: {evex}	xorw	%dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x31,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	xorw	%dx, 291(%r8,%rax,4)
# CHECK: {nf}	xorw	%dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x31,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorw	%dx, 291(%r8,%rax,4)
# CHECK: xorw	%dx, 291(%r8,%rax,4), %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x31,0x94,0x80,0x23,0x01,0x00,0x00]
         xorw	%dx, 291(%r8,%rax,4), %ax
# CHECK: {nf}	xorw	%dx, 291(%r8,%rax,4), %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x31,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorw	%dx, 291(%r8,%rax,4), %ax
# CHECK: {evex}	xorl	%ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x31,0xca]
         {evex}	xorl	%ecx, %edx
# CHECK: {nf}	xorl	%ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x31,0xca]
         {nf}	xorl	%ecx, %edx
# CHECK: xorl	%ecx, %edx, %r10d
# CHECK: encoding: [0x62,0xf4,0x2c,0x18,0x31,0xca]
         xorl	%ecx, %edx, %r10d
# CHECK: {nf}	xorl	%ecx, %edx, %r10d
# CHECK: encoding: [0x62,0xf4,0x2c,0x1c,0x31,0xca]
         {nf}	xorl	%ecx, %edx, %r10d
# CHECK: {evex}	xorl	%ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x31,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	xorl	%ecx, 291(%r8,%rax,4)
# CHECK: {nf}	xorl	%ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x31,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorl	%ecx, 291(%r8,%rax,4)
# CHECK: xorl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x31,0x8c,0x80,0x23,0x01,0x00,0x00]
         xorl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: {nf}	xorl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x31,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: {evex}	xorq	%r9, %r15
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x31,0xcf]
         {evex}	xorq	%r9, %r15
# CHECK: {nf}	xorq	%r9, %r15
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x31,0xcf]
         {nf}	xorq	%r9, %r15
# CHECK: xorq	%r9, %r15, %r11
# CHECK: encoding: [0x62,0x54,0xa4,0x18,0x31,0xcf]
         xorq	%r9, %r15, %r11
# CHECK: {nf}	xorq	%r9, %r15, %r11
# CHECK: encoding: [0x62,0x54,0xa4,0x1c,0x31,0xcf]
         {nf}	xorq	%r9, %r15, %r11
# CHECK: {evex}	xorq	%r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x31,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	xorq	%r9, 291(%r8,%rax,4)
# CHECK: {nf}	xorq	%r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x31,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorq	%r9, 291(%r8,%rax,4)
# CHECK: xorq	%r9, 291(%r8,%rax,4), %r15
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x31,0x8c,0x80,0x23,0x01,0x00,0x00]
         xorq	%r9, 291(%r8,%rax,4), %r15
# CHECK: {nf}	xorq	%r9, 291(%r8,%rax,4), %r15
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x31,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorq	%r9, 291(%r8,%rax,4), %r15
# CHECK: {evex}	xorb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x32,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	xorb	291(%r8,%rax,4), %bl
# CHECK: {nf}	xorb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x32,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorb	291(%r8,%rax,4), %bl
# CHECK: xorb	291(%r8,%rax,4), %bl, %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x32,0x9c,0x80,0x23,0x01,0x00,0x00]
         xorb	291(%r8,%rax,4), %bl, %cl
# CHECK: {nf}	xorb	291(%r8,%rax,4), %bl, %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x32,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorb	291(%r8,%rax,4), %bl, %cl
# CHECK: {evex}	xorw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x33,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	xorw	291(%r8,%rax,4), %dx
# CHECK: {nf}	xorw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x33,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorw	291(%r8,%rax,4), %dx
# CHECK: xorw	291(%r8,%rax,4), %dx, %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x33,0x94,0x80,0x23,0x01,0x00,0x00]
         xorw	291(%r8,%rax,4), %dx, %ax
# CHECK: {nf}	xorw	291(%r8,%rax,4), %dx, %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x33,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorw	291(%r8,%rax,4), %dx, %ax
# CHECK: {evex}	xorl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x33,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	xorl	291(%r8,%rax,4), %ecx
# CHECK: {nf}	xorl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x33,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorl	291(%r8,%rax,4), %ecx
# CHECK: xorl	291(%r8,%rax,4), %ecx, %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x33,0x8c,0x80,0x23,0x01,0x00,0x00]
         xorl	291(%r8,%rax,4), %ecx, %edx
# CHECK: {nf}	xorl	291(%r8,%rax,4), %ecx, %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x33,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorl	291(%r8,%rax,4), %ecx, %edx
# CHECK: {evex}	xorq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x33,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	xorq	291(%r8,%rax,4), %r9
# CHECK: {nf}	xorq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x33,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorq	291(%r8,%rax,4), %r9
# CHECK: xorq	291(%r8,%rax,4), %r9, %r15
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x33,0x8c,0x80,0x23,0x01,0x00,0x00]
         xorq	291(%r8,%rax,4), %r9, %r15
# CHECK: {nf}	xorq	291(%r8,%rax,4), %r9, %r15
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x33,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	xorq	291(%r8,%rax,4), %r9, %r15
